%define release 1
%define prefix  /usr
%define name	stardict
%define version 2.4.5


Summary: 	StarDict dictionary
Name:		%{name}
Version:    %{version}
Release:	%{release}
License: 	GPL
Vendor:		GNOME
URL: 		http://stardict.sourceforge.net
Group: 		Applications/System
Source0:	%{name}-%{version}.tar.bz2
Packager:       Hu Zheng <huzheng_001@163.com>
BuildRoot:	%{_builddir}/%{name}-%{version}-root

BuildRequires: libgnomeui-devel >= 2.2.0


Requires: libgnome >= 2.2.0
Requires: libgnomeui >= 2.2.0
Requires: libbonobo >= 2.2.0
Requires: bonobo-activation >= 2.2.0

Docdir:         %{prefix}/share/doc

%description
StarDict is a Cross-Platform and international dictionary written in Gtk2.
It has powerful features such as "Glob-style pattern matching," "Scan
seletion word," "Fuzzy search," etc.

%prep
%setup

%build

%configure --disable-schemas-install
make

%install
rm -rf $RPM_BUILD_ROOT
make DESTDIR=$RPM_BUILD_ROOT install

%clean
rm -rf $RPM_BUILD_ROOT


%files
%defattr(-, root, root)
%{_bindir}/stardict
%{_datadir}/applications/stardict.desktop
%{_datadir}/stardict
%{_datadir}/locale/*/LC_MESSAGES/stardict.mo
%{_datadir}/idl
%{_libdir}/bonobo/servers/*.server
%{_datadir}/pixmaps/stardict.png
%{_sysconfdir}/gconf/schemas/*.schemas
%{_datadir}/omf
%doc %{_datadir}/man/man1/stardict.1*
%doc %{_datadir}/gnome/help/stardict


%post
GCONF_CONFIG_SOURCE=`gconftool-2 --get-default-source` gconftool-2 --makefile-install-rule %{_sysconfdir}/gconf/schemas/stardict.schemas >/dev/null
if which scrollkeeper-update>/dev/null 2>&1; then scrollkeeper-update; fi

%postun
if which scrollkeeper-update>/dev/null 2>&1; then scrollkeeper-update; fi

%changelog
* Wed Jul 20 2005 Hu Zheng  <huzheng_001@163.com> 2.4.5
- Public release of StarDict 2.4.5.

* Sun Nov 28 2004 Hu Zheng  <huzheng_001@163.com> 2.4.4
- Public release of StarDict 2.4.4.

* Thu Feb 19 2004 Hu Zheng <huzheng_001@163.com> 2.4.3
- Public release of StarDict 2.4.3.

* Sat Nov 15 2003 Hu Zheng <huzheng_001@163.com> 2.4.2
- Public release of StarDict 2.4.2.

* Sun Sep 28 2003 Hu Zheng <huzheng_001@163.com> 2.4.1
- Public release of StarDict 2.4.1.

* Thu Aug 28 2003 Hu Zheng <huzheng_001@163.com> 2.4.0
- Public release of StarDict 2.4.0.

* Sat Jun 28 2003 Hu Zheng <huzheng_001@163.com> 2.2.1
- Public release of StarDict 2.2.1.

* Sun Jun 01 2003 Hu Zheng <huzheng_001@163.com> 2.2.0
- Public release of StarDict 2.2.0.

* Sun May 18 2003 Hu Zheng <huzheng_001@163.com> 2.1.0
- Public release of StarDict 2.1.0.

* Fri May 02 2003 Hu Zheng <huzheng_001@163.com> 2.0.0
- Public release of StarDict 2.0.0.

* Wed Apr  9 2003 Hu Zheng <huzheng_001@163.com> 2.0.0-pre2
- Second public preview release of StarDict 2.

* Sun Mar 30 2003 Hu Zheng <huzheng_001@163.com> 2.0.0-pre1
- First public preview release of StarDict 2.
